namespace DataLayer.Primitive.Core
{
	using System;
	using System.Data.SqlClient;

	using CommonLayer.Exceptions;
	using CommonLayer.Customs;

	internal class PrimitiveAdapter
	{
		public PrimitiveAdapter()
		{
		}

		public static CustomDataSet Fill( PrimitiveCommand Command )
		{
			SqlDataAdapter _adapter = new SqlDataAdapter( Command.Command );
            CustomDataSet _data = new CustomDataSet();

			try { _adapter.SelectCommand.Connection.Open(); }
			catch( Exception ex ) { throw new ExceptionCannotOpenDataBase( _adapter.SelectCommand.Connection.ConnectionString, ex.Message ); }

			try { _adapter.Fill( _data.Data, Command.Procedure.Table ); }
			catch( Exception ex ) { throw new ExceptionCrashFillDataSet( _adapter.SelectCommand.CommandText, ex.Message ); }
			finally { _adapter.SelectCommand.Connection.Close(); }

            return _data;
		}
	}
}
