namespace DataLayer.Primitive.Core
{
	using System;
	using System.Data;
	using System.Data.SqlClient;

	internal class PrimitiveCommand
	{
		private SqlCommand _command;
		private PrimitiveProcedure _procedure;

		public PrimitiveCommand( PrimitiveProcedure Procedure )
		{
			this._procedure = Procedure;
            this._command = new SqlCommand( Procedure.Name, PrimitiveConnection.Create() );
			this._command.CommandType = CommandType.StoredProcedure;
		}

		public PrimitiveCommand( PrimitiveSql Sql )
		{
			this._procedure = new PrimitiveProcedure( "", Sql.Name );
			this._command = new SqlCommand( Sql.Text, PrimitiveConnection.Create() );
			this._command.CommandType = CommandType.Text;
		}

		public SqlCommand Command
		{
			get { return this._command; }
		}

		public PrimitiveProcedure Procedure
		{
			get { return this._procedure; }
		}

		public void Assign( PrimitiveParameterCollection Collection )
		{
			foreach( PrimitiveParameter Item in Collection.Values )
				this._command.Parameters.Add( Item.Parameter );
		}
	}
}
