namespace DataLayer.Primitive.Core
{
	using System;
	using System.Data;

	using CommonLayer.Nullables;
	using CommonLayer.Customs;
	using CommonLayer.Exceptions;

	internal class PrimitiveHelper
	{
		private PrimitiveHelper()
		{
		}

		public static CustomDataSet ExecuteDataSet( 
			PrimitiveProcedure Procedure, 
			PrimitiveParameterCollection Collection )
		{
            PrimitiveCommand Command = new PrimitiveCommand( Procedure );
			Command.Assign( Collection );
			return PrimitiveAdapter.Fill( Command );
		}

		public static CustomDataSet ExecuteDataSet( PrimitiveSql Sql )
		{
            PrimitiveCommand Command = new PrimitiveCommand( Sql );
            return PrimitiveAdapter.Fill( Command );
		}

		public static void ExecuteNonQuery( String SqlText )
		{
            PrimitiveSql Sql = new PrimitiveSql( SqlText, "" );
            PrimitiveCommand Command = new PrimitiveCommand( Sql );

			Command.Command.Connection.Open();
			try { Command.Command.ExecuteNonQuery(); }
			catch( Exception ex ) { throw new ExceptionExecuteNonQuery( Command.Command.CommandText, ex.Message ); }
			finally { Command.Command.Connection.Close(); }
		}

		public static void ExecuteNonQuery(
			PrimitiveProcedure Procedure, 
			PrimitiveParameterCollection Collection )
		{
			PrimitiveCommand Command = new PrimitiveCommand( Procedure );
			Command.Assign( Collection );

			Command.Command.Connection.Open();
			try { Command.Command.ExecuteNonQuery(); }
			catch( Exception ex ) { throw new ExceptionExecuteNonQuery( Command.Command.CommandText, ex.Message ); }
			finally { Command.Command.Connection.Close(); }   
		}
	}
}
