namespace DataLayer.Primitive
{
	using System;
	using System.Data.SqlClient;

	using Core;
	using CommonLayer.Customs;

	public sealed class PrimitiveExecutable
	{
		private PrimitiveParameterCollection _collection;

		public PrimitiveExecutable()
		{
			this._collection = new PrimitiveParameterCollection();
		}

		public void DefineParameter( PrimitiveParameter Parameter )
		{
			this._collection.Add( Parameter );
		}

		public CustomDataSet ExecuteDataSet( PrimitiveProcedure Procedure )
		{
			return PrimitiveHelper.ExecuteDataSet( Procedure, this._collection );
		}

		public void ExecuteNonQuery( PrimitiveProcedure Procedure )
		{
			PrimitiveHelper.ExecuteNonQuery( Procedure, this._collection );
		}

		public void ClearParamters()
		{
			this._collection.Clear();
		}
	}
}