namespace DataLayer.WinApp
{
	using System;
	using DataLayer.Primitive;
	
	public class DataOption : PrimitiveEntity
	{
		private Int32 _id;
		private Int32 _position;

		public DataOption(
			Int32 Id,
			Int32 Position ) : base( "option" )
		{
			this._id = Id;
			this._position = Position;
		}

		public Int32 Id
		{
			get { return this._id; }
		}

		public void Insert()
		{
			this.InnerInsert();
			this._id = (Int32)this._collection[ "@option_id" ].Parameter.Value;
		}

		protected override void OnInsert()
		{
			base.OnInsert();
			this._collection.Add( PrimitiveParameter.CreateInput( "@option_position", this._position ) );
			this._collection.Add( PrimitiveParameter.CreateOutputInt32( "@option_id" ) );
		}
	}
}
